git-pull.shon commit Merge branch 'ah/doc-gitk-config' (b2273d0)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# Fetch one or more remote refs and merge it/them into the current HEAD.
   6
   7USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff|--ff-only] [--[no-]rebase|--rebase=preserve] [-s strategy]... [<fetch-options>] <repo> <head>...'
   8LONG_USAGE='Fetch one or more remote refs and integrate it/them with the current HEAD.'
   9SUBDIRECTORY_OK=Yes
  10OPTIONS_SPEC=
  11. git-sh-setup
  12. git-sh-i18n
  13set_reflog_action "pull${1+ $*}"
  14require_work_tree_exists
  15cd_to_toplevel
  16
  17
  18die_conflict () {
  19    git diff-index --cached --name-status -r --ignore-submodules HEAD --
  20    if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
  21        die "$(gettext "Pull is not possible because you have unmerged files.
  22Please, fix them up in the work tree, and then use 'git add/rm <file>'
  23as appropriate to mark resolution, or use 'git commit -a'.")"
  24    else
  25        die "$(gettext "Pull is not possible because you have unmerged files.")"
  26    fi
  27}
  28
  29die_merge () {
  30    if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
  31        die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
  32Please, commit your changes before you can merge.")"
  33    else
  34        die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
  35    fi
  36}
  37
  38test -z "$(git ls-files -u)" || die_conflict
  39test -f "$GIT_DIR/MERGE_HEAD" && die_merge
  40
  41bool_or_string_config () {
  42        git config --bool "$1" 2>/dev/null || git config "$1"
  43}
  44
  45strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
  46log_arg= verbosity= progress= recurse_submodules= verify_signatures=
  47merge_args= edit= rebase_args=
  48curr_branch=$(git symbolic-ref -q HEAD)
  49curr_branch_short="${curr_branch#refs/heads/}"
  50rebase=$(bool_or_string_config branch.$curr_branch_short.rebase)
  51if test -z "$rebase"
  52then
  53        rebase=$(bool_or_string_config pull.rebase)
  54fi
  55
  56# Setup default fast-forward options via `pull.ff`
  57pull_ff=$(git config pull.ff)
  58case "$pull_ff" in
  59false)
  60        no_ff=--no-ff
  61        break
  62        ;;
  63only)
  64        ff_only=--ff-only
  65        break
  66        ;;
  67esac
  68
  69
  70dry_run=
  71while :
  72do
  73        case "$1" in
  74        -q|--quiet)
  75                verbosity="$verbosity -q" ;;
  76        -v|--verbose)
  77                verbosity="$verbosity -v" ;;
  78        --progress)
  79                progress=--progress ;;
  80        --no-progress)
  81                progress=--no-progress ;;
  82        -n|--no-stat|--no-summary)
  83                diffstat=--no-stat ;;
  84        --stat|--summary)
  85                diffstat=--stat ;;
  86        --log|--no-log)
  87                log_arg=$1 ;;
  88        --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
  89                no_commit=--no-commit ;;
  90        --c|--co|--com|--comm|--commi|--commit)
  91                no_commit=--commit ;;
  92        -e|--edit)
  93                edit=--edit ;;
  94        --no-edit)
  95                edit=--no-edit ;;
  96        --sq|--squ|--squa|--squas|--squash)
  97                squash=--squash ;;
  98        --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
  99                squash=--no-squash ;;
 100        --ff)
 101                no_ff=--ff ;;
 102        --no-ff)
 103                no_ff=--no-ff ;;
 104        --ff-only)
 105                ff_only=--ff-only ;;
 106        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 107                --strateg=*|--strategy=*|\
 108        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 109                case "$#,$1" in
 110                *,*=*)
 111                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 112                1,*)
 113                        usage ;;
 114                *)
 115                        strategy="$2"
 116                        shift ;;
 117                esac
 118                strategy_args="${strategy_args}-s $strategy "
 119                ;;
 120        -X*)
 121                case "$#,$1" in
 122                1,-X)
 123                        usage ;;
 124                *,-X)
 125                        xx="-X $(git rev-parse --sq-quote "$2")"
 126                        shift ;;
 127                *,*)
 128                        xx=$(git rev-parse --sq-quote "$1") ;;
 129                esac
 130                merge_args="$merge_args$xx "
 131                ;;
 132        -r=*|--r=*|--re=*|--reb=*|--reba=*|--rebas=*|--rebase=*)
 133                rebase="${1#*=}"
 134                ;;
 135        -r|--r|--re|--reb|--reba|--rebas|--rebase)
 136                rebase=true
 137                ;;
 138        --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
 139                rebase=false
 140                ;;
 141        --recurse-submodules)
 142                recurse_submodules=--recurse-submodules
 143                ;;
 144        --recurse-submodules=*)
 145                recurse_submodules="$1"
 146                ;;
 147        --no-recurse-submodules)
 148                recurse_submodules=--no-recurse-submodules
 149                ;;
 150        --verify-signatures)
 151                verify_signatures=--verify-signatures
 152                ;;
 153        --no-verify-signatures)
 154                verify_signatures=--no-verify-signatures
 155                ;;
 156        --gpg-sign|-S)
 157                gpg_sign_args=-S
 158                ;;
 159        --gpg-sign=*)
 160                gpg_sign_args=$(git rev-parse --sq-quote "-S${1#--gpg-sign=}")
 161                ;;
 162        -S*)
 163                gpg_sign_args=$(git rev-parse --sq-quote "$1")
 164                ;;
 165        --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
 166                dry_run=--dry-run
 167                ;;
 168        -h|--help-all)
 169                usage
 170                ;;
 171        *)
 172                # Pass thru anything that may be meant for fetch.
 173                break
 174                ;;
 175        esac
 176        shift
 177done
 178
 179case "$rebase" in
 180preserve)
 181        rebase=true
 182        rebase_args=--preserve-merges
 183        ;;
 184true|false|'')
 185        ;;
 186*)
 187        echo "Invalid value for --rebase, should be true, false, or preserve"
 188        usage
 189        exit 1
 190        ;;
 191esac
 192
 193error_on_no_merge_candidates () {
 194        exec >&2
 195        for opt
 196        do
 197                case "$opt" in
 198                -t|--t|--ta|--tag|--tags)
 199                        echo "It doesn't make sense to pull all tags; you probably meant:"
 200                        echo "  git fetch --tags"
 201                        exit 1
 202                esac
 203        done
 204
 205        if test true = "$rebase"
 206        then
 207                op_type=rebase
 208                op_prep=against
 209        else
 210                op_type=merge
 211                op_prep=with
 212        fi
 213
 214        upstream=$(git config "branch.$curr_branch_short.merge")
 215        remote=$(git config "branch.$curr_branch_short.remote")
 216
 217        if [ $# -gt 1 ]; then
 218                if [ "$rebase" = true ]; then
 219                        printf "There is no candidate for rebasing against "
 220                else
 221                        printf "There are no candidates for merging "
 222                fi
 223                echo "among the refs that you just fetched."
 224                echo "Generally this means that you provided a wildcard refspec which had no"
 225                echo "matches on the remote end."
 226        elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
 227                echo "You asked to pull from the remote '$1', but did not specify"
 228                echo "a branch. Because this is not the default configured remote"
 229                echo "for your current branch, you must specify a branch on the command line."
 230        elif [ -z "$curr_branch" -o -z "$upstream" ]; then
 231                . git-parse-remote
 232                error_on_missing_default_upstream "pull" $op_type $op_prep \
 233                        "git pull <remote> <branch>"
 234        else
 235                echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
 236                echo "from the remote, but no such ref was fetched."
 237        fi
 238        exit 1
 239}
 240
 241test true = "$rebase" && {
 242        if ! git rev-parse -q --verify HEAD >/dev/null
 243        then
 244                # On an unborn branch
 245                if test -f "$GIT_DIR/index"
 246                then
 247                        die "$(gettext "updating an unborn branch with changes added to the index")"
 248                fi
 249        else
 250                require_clean_work_tree "pull with rebase" "Please commit or stash them."
 251        fi
 252        oldremoteref= &&
 253        test -n "$curr_branch" &&
 254        . git-parse-remote &&
 255        remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
 256        oldremoteref=$(git merge-base --fork-point "$remoteref" $curr_branch 2>/dev/null)
 257}
 258orig_head=$(git rev-parse -q --verify HEAD)
 259git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
 260test -z "$dry_run" || exit 0
 261
 262curr_head=$(git rev-parse -q --verify HEAD)
 263if test -n "$orig_head" && test "$curr_head" != "$orig_head"
 264then
 265        # The fetch involved updating the current branch.
 266
 267        # The working tree and the index file is still based on the
 268        # $orig_head commit, but we are merging into $curr_head.
 269        # First update the working tree to match $curr_head.
 270
 271        eval_gettextln "Warning: fetch updated the current branch head.
 272Warning: fast-forwarding your working tree from
 273Warning: commit \$orig_head." >&2
 274        git update-index -q --refresh
 275        git read-tree -u -m "$orig_head" "$curr_head" ||
 276                die "$(eval_gettext "Cannot fast-forward your working tree.
 277After making sure that you saved anything precious from
 278$ git diff \$orig_head
 279output, run
 280$ git reset --hard
 281to recover.")"
 282
 283fi
 284
 285merge_head=$(sed -e '/  not-for-merge   /d' \
 286        -e 's/  .*//' "$GIT_DIR"/FETCH_HEAD | \
 287        tr '\012' ' ')
 288
 289case "$merge_head" in
 290'')
 291        error_on_no_merge_candidates "$@"
 292        ;;
 293?*' '?*)
 294        if test -z "$orig_head"
 295        then
 296                die "$(gettext "Cannot merge multiple branches into empty head")"
 297        fi
 298        if test true = "$rebase"
 299        then
 300                die "$(gettext "Cannot rebase onto multiple branches")"
 301        fi
 302        ;;
 303esac
 304
 305# Pulling into unborn branch: a shorthand for branching off
 306# FETCH_HEAD, for lazy typers.
 307if test -z "$orig_head"
 308then
 309        # Two-way merge: we claim the index is based on an empty tree,
 310        # and try to fast-forward to HEAD.  This ensures we will not
 311        # lose index/worktree changes that the user already made on
 312        # the unborn branch.
 313        empty_tree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 314        git read-tree -m -u $empty_tree $merge_head &&
 315        git update-ref -m "initial pull" HEAD $merge_head "$curr_head"
 316        exit
 317fi
 318
 319if test true = "$rebase"
 320then
 321        o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
 322        if test "$oldremoteref" = "$o"
 323        then
 324                unset oldremoteref
 325        fi
 326fi
 327
 328merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit
 329case "$rebase" in
 330true)
 331        eval="git-rebase $diffstat $strategy_args $merge_args $rebase_args $verbosity"
 332        eval="$eval $gpg_sign_args"
 333        eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
 334        ;;
 335*)
 336        eval="git-merge $diffstat $no_commit $verify_signatures $edit $squash $no_ff $ff_only"
 337        eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
 338        eval="$eval $gpg_sign_args"
 339        eval="$eval \"\$merge_name\" HEAD $merge_head"
 340        ;;
 341esac
 342eval "exec $eval"